/**
  ******************************************************************************
  * @file    cmd.c 
  * @author  MCD Application Team
  * @version V1.0.0
  * @date    11/20/2009
  * @brief   A hello world example based on a Telnet connection
  *          The application works as a server which wait for the client request
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
  */ 

/* Includes ------------------------------------------------------------------*/
#include "cmd.h"
#include <stdio.h>


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define IN_USER 	"Please enter your username:\r\n"  //ûʾ
#define USER_ERR 	"UserName wrong:\r\n"			   //ûʾ
#define IN_PWD 		"Please enter your password:\r\n"  //ʾ
#define PWD_ERR 	"\r\nPWD wrong:\r\n"
#define IN_CMD 		"\r\nPlease enter command:\r\n"	  //ʾ
#define CMD_ERR		"\r\nCommand not found!"
#define STATUS_ON	"\r\n Success,LED1 status is ON!\r\n"
#define STATUS_OFF	"\r\n Success,LED1 status is OFF!\r\n"

#define MAX_NAME_SIZE 15						  //ֵֽ

struct dat 		//ڱclient֡
{
  int length;
  char bytes[MAX_NAME_SIZE];
};

struct r_ctrl
{
 	char user[MAX_NAME_SIZE];//û
	char PWD[MAX_NAME_SIZE]; //
	char CMD[MAX_NAME_SIZE]; //
};

struct r_ctrl r_msg;

/* Private functions ---------------------------------------------------------*/


/*
 * CMD_recv
 *   client˵
 *   tcp_argõĲpcbṹ壬pbuferr
 *   : err_t
 *   ڲ
 */
static err_t CMD_recv(void *arg, struct tcp_pcb *pcb, struct pbuf *p, err_t err)
{
  struct pbuf *q;
  struct dat *dat = (struct dat *)arg;
  int done;
  char *c;
  int i;	  

  /* We perform here any necessary processing on the pbuf */
  if (p != NULL)   //pbufǿ
  {        
	/* We call this function to tell the LwIp that we have processed the data */
	/* This lets the stack advertise a larger window, so more data can be received*/
	tcp_recved(pcb, p->tot_len); //pbuf

    /* Check the name if NULL, no data passed, return withh illegal argument error */
	if(!dat) 				 //Ϊʱͷڴ
    {
      pbuf_free(p);
      return ERR_ARG;
    }

    done = 0;
    for(q=p; q != NULL; q = q->next) 	 //qΪpbufָ
    {
      c = q->payload;					 //cȡpbufеָpayload
      for(i=0; i<q->len && !done; i++) 
	  {
        done = ((c[i] == '\r') || (c[i] == '\n'));	//յس
        if(dat->length < MAX_NAME_SIZE) 			 //ַ浽ṹ
	    {
          dat->bytes[dat->length++] = c[i];	//payloadеݵnameṹ
        }
      }
    } 


    if(done) 
    {
		/*windows£س \r\n linux£س \n */

      if(dat->bytes[dat->length-2] != '\r' || dat->bytes[dat->length-1] != '\n') 
	  {
        if((dat->bytes[dat->length-1] == '\r' || dat->bytes[dat->length-1] == '\n') && (dat->length+1 <= MAX_NAME_SIZE)) 
	    {
	      dat->length += 1; //linux 
        } 
	    else if(dat->length+2 <= MAX_NAME_SIZE) 
	    {
          dat->length += 2; //windows
        } 
	    else 
	    {
          dat->length = MAX_NAME_SIZE;	//ﵽֵ
        }

//        name->bytes[name->length-2] = '\r';	 //תΪ׼\r\nַʾس
//        name->bytes[name->length-1] = '\n';	 
	
		dat->bytes[dat->length-2] = '\0'; //ӽȡbytes
      }
		

	   	if(strcmp(r_msg.user,"wildfire")==0) //û
			{
				//	 printf("\r\n r_msg.user=%s",r_msg.user);

			   if(strcmp(r_msg.PWD,"123456")==0)	//
			   		{
						strcpy(r_msg.CMD,dat->bytes);	 //

						 if(strcmp(r_msg.CMD,"LED1_ON")==0)	//
						   {
						   	 LED1(ON);
						   	 tcp_write(pcb,STATUS_ON, strlen(STATUS_ON), 1);//Ƴɹ	 
							 tcp_write(pcb,IN_CMD, strlen(IN_CMD), 1);	 //ʾһ
							  }
						 else if(strcmp(r_msg.CMD,"LED1_OFF")==0)	//ص
						   {
						   		LED1(OFF);
							   	tcp_write(pcb,STATUS_OFF, strlen(STATUS_OFF), 1);//Ƴɹ	 
								tcp_write(pcb,IN_CMD, strlen(IN_CMD), 1);	  //ʾһ
						   }
						 else  //Ҳ
						 	{
							tcp_write(pcb,CMD_ERR, strlen(CMD_ERR), 1);	 //
							tcp_write(pcb,IN_CMD, strlen(IN_CMD), 1);	 //ʾһ
							}

					 }
				else if(strcmp(dat->bytes,"123456")==0)//һ룬ȷ
				   	{
					strcpy(r_msg.PWD,dat->bytes);	 //
					tcp_write(pcb,IN_CMD, strlen(IN_CMD), 1);	 //ʾһ

					}
				else //
				{	
				tcp_write(pcb,PWD_ERR, strlen(PWD_ERR), 1);	 //
				}
			}
		else //һû
			{
				if(strcmp(dat->bytes,"wildfire")==0)	//ûȷ
				{
					strcpy(r_msg.user,dat->bytes);	//ȷû
				  	tcp_write(pcb,IN_PWD, strlen(IN_PWD), 1);	 //ʾ
				
				 }
				else//û
					{
					tcp_write(pcb, USER_ERR, strlen(USER_ERR), 1); //û
					tcp_write(pcb, IN_USER, strlen(IN_USER), 1); //ʾٴ
					}			 	
			} 
      dat->length = 0;	
    }
	
	/* End of processing, we free the pbuf */
    pbuf_free(p);	  //ͷpbuf
  }  
  else if (err == ERR_OK) 
  {
    /* When the pbuf is NULL and the err is ERR_OK, the remote end is closing the connection. */
    /* We free the allocated memory and we close the connection */
    mem_free(dat);
    return tcp_close(pcb);
  }	    

  return ERR_OK; 

}  




/*
 * CMD_accept
 *   telnetӽõĻص
 *   ûԶӵpcbƿ顢errorֵ
 *   : ERROK
 *   ⲿ
 */  
static err_t CMD_accept(void *arg, struct tcp_pcb *pcb, err_t err)
{     
   /*ָĲmem_callocһռָ룩ݸĻص*/
  /* Tell LwIP to associate this structure with this connection. */
  tcp_arg(pcb, mem_calloc(sizeof(struct dat), 1));	  
  
  /* Configure LwIP to use our call back functions. */
  tcp_err(pcb, CMD_conn_err);   //ʱõĻصHelloWorld_conn_err
  tcp_recv(pcb, CMD_recv);	   //ڽclientݵĻصHelloWorld_recv
  
  /* Send out the first message */  
  tcp_write(pcb, IN_USER, strlen(IN_USER), 1); //ͻӭַ

  return ERR_OK;
}

/*
 * CMD_init
 *   ʼtelnetõԶ̿С
 *   
 *   : 
 *   ⲿ
 */
void CMD_init(void)
{
  struct tcp_pcb *pcb;		//һtcpƿ            		
  
  /* Create a new TCP control block  */
  pcb = tcp_new();	   		//tcpƿڴռ             		 	

  /* Assign to the new pcb a local IP address and a port number */
  /* Using IP_ADDR_ANY allow the pcb to be used by any local interface */
  tcp_bind(pcb, IP_ADDR_ANY, 23);     //PCBƿ󶨵IPַ˿Ϊ23  


  /* Set the connection to the LISTEN state */
  pcb = tcp_listen(pcb);			  //ö˿	

  /* Specify the function to be called when a connection is established */	
  tcp_accept(pcb, CMD_accept);   	 //Ķ˿ڽͨõĺHelloWorld_accept
										
}


  /*
 * CMD_conn_err
 *   ʱñ
 *   tcp_arg룬err
 *   : 
 *   ⲿ
 */
static void CMD_conn_err(void *arg, err_t err)
{
  struct dat *dat;
  dat = (struct dat *)arg;

  mem_free(dat);
}

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/


