/******************** (C) COPYRIGHT 2012 WildFire Team ***************************
 * ļ  LWIP_Init.c
 *     LWIPЭջʼʼ         
 * ʵƽ̨ҰSTM32
 
 * 汾  ST3.5.0
 *      
 * ̳    www.ourdev.cn/bbs/bbs_list.jsp?bbs_id=1008
 * Ա    http://firestm32.taobao.com
**********************************************************************************/

#include "netconfig.h"	

#define SYSTEMTICK_PERIOD_MS  10 
#define INPUT_TMR_INTERVAL 	  2

__IO uint32_t TCPTimer = 0;
__IO uint32_t ARPTimer = 0;
__IO uint32_t INPUT_Timer=0;

#ifdef LWIP_DHCP
__IO uint32_t DHCPfineTimer = 0;
__IO uint32_t DHCPcoarseTimer = 0;

#endif 
 	
struct netif enc28j60;	  		//netif ӿڽṹӲӿڵ
uint8_t macaddress[6]={0x54,0x55,0x58,0x10,0x00,0x24};	//ӿڵmacַ
extern __IO uint32_t LocalTime;

/**ⲿ*/
extern err_t ethernetif_init( struct netif *netif );  //ethernetif.cж
extern err_t ethernetif_input( struct netif *netif );  //ethernetif.cж

/*
 * LWIP_Init
 *   ʼLWIPЭջҪǰenc28j60LWIP
 			IPMACַӿں
 *   
 *   : 
 *   ⲿ
 */
void LwIP_Init( void )
{
  struct ip_addr ipaddr;
  struct ip_addr netmask;
  struct ip_addr gw;

   /*LWIPʼ
   ʼӿڽṹڴءpbufṹ*/
   lwip_init();	
	  
#if LWIP_DHCP			   					//ʹDHCPЭ
  ipaddr.addr = 0;
  netmask.addr = 0;
  gw.addr = 0; 
#else										//
  IP4_ADDR(&ipaddr, 192, 168, 1, 18);  		//ӿڵipַ
  IP4_ADDR(&netmask, 255, 255, 255, 0);		//
  IP4_ADDR(&gw, 192, 168, 1, 1);			//

#endif
   
  /*ʼenc28j60LWIPĽӿڣΪӿڽṹ塢ipַ
  롢ءϢָ롢ʼ뺯*/
  netif_add(&enc28j60, &ipaddr, &netmask, &gw, NULL, &ethernetif_init, &ethernet_input);
 
  /*enc28j60ΪĬ .*/
  netif_set_default(&enc28j60);


#if LWIP_DHCP	   			//ʹDHCP
  /*  Creates a new DHCP client for this interface on the first call.
  Note: you must call dhcp_fine_tmr() and dhcp_coarse_tmr() at
  the predefined regular intervals after starting the client.
  You can peek in the netif->dhcp struct for the actual DHCP status.*/
  dhcp_start(&enc28j60);   	//DHCP
#endif

  /*  When the netif is fully configured this function must be called.*/
  netif_set_up(&enc28j60); //ʹenc28j60ӿ
}

/*
 * Time_Update
 *   ڸLocalTimeֵ   	 		
 *   
 *   : 
 *   ⲿ
 */	 
void Time_Update(void)
{
  LocalTime += SYSTEMTICK_PERIOD_MS;
}


/*
 * LwIP_Periodic_Handle
 *   lwipЭջҪڵһЩ
 			tcp_tmr  etharp_tmr   dhcp_fine_tmr dhcp_coarse_tmr	 		
 *   
 *   : 
 *   ⲿ
 */
void LwIP_Periodic_Handle(__IO uint32_t localtime)
{
	//err_t  err;
	
	if(localtime - INPUT_Timer >= INPUT_TMR_INTERVAL)
		{
		    /* Read a received packet from the Ethernet buffers and send it to the lwIP for handling */
			ethernetif_input(&enc28j60); 			//ѯǷյ
			//	err = ethernetif_input(&enc28j60); //ѯǷյ

			//		if (err !=ERR_OK  ) 
			//		{
			//			
			//
			//			}
		}

	  /* TCP periodic process every 250 ms */
	  if (localtime - TCPTimer >= TCP_TMR_INTERVAL)
	  {
	    TCPTimer =  localtime;
	    tcp_tmr();		 //ÿ250msһ
	  }
	  /* ARP periodic process every 5s */
	  if (localtime - ARPTimer >= ARP_TMR_INTERVAL)
	  {
	    ARPTimer =  localtime;
	    etharp_tmr();	  //ÿ5sһ
	  }

#if LWIP_DHCP
	  /* Fine DHCP periodic process every 500ms */
	  if (localtime - DHCPfineTimer >= DHCP_FINE_TIMER_MSECS)
	  {
	    DHCPfineTimer =  localtime;
	    dhcp_fine_tmr();
	  }
	  /* DHCP Coarse periodic process every 60s */
	  if (localtime - DHCPcoarseTimer >= DHCP_COARSE_TIMER_MSECS)
	  {
	    DHCPcoarseTimer =  localtime;
	    dhcp_coarse_tmr();
	  }
#endif

}
